BaseHandler
hololinked.server.http.handlers.BaseHandler
Bases: RequestHandler
Base request handler for running operations on the Thing.
Source code in repo/hololinked/hololinked/server/http/handlers.py
57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 | |
Attributes
Functions
initialize
initialize(resource: InteractionAffordance | PropertyAffordance | ActionAffordance | EventAffordance, config: RuntimeConfig, logger: BoundLogger, thing: Thing, metadata: HandlerMetadata | None = None) -> None
Set up the handler with the affordance it serves and the server's runtime configuration.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
|
InteractionAffordance | PropertyAffordance | ActionAffordance | EventAffordance
|
dataclass representation of |
required |
|
HandlerMetadata | None
|
additional metadata about the resource, like allowed HTTP methods |
None
|
|
Thing
|
the |
required |
Source code in repo/hololinked/hololinked/server/http/handlers.py
has_access_control
async
Checks if a client is an allowed client and enforces security schemes.
Custom web request handlers can use this property to check if a client has access control on the server or Thing
and let this property automatically generate a 401/403.
Returns:
| Type | Description |
|---|---|
bool
|
|
Source code in repo/hololinked/hololinked/server/http/handlers.py
is_authenticated
async
Enforces authentication using the defined security schemes, freshly computed everytime.
Returns:
| Type | Description |
|---|---|
bool
|
|
Source code in repo/hololinked/hololinked/server/http/handlers.py
is_authorized
async
Enforces authorization using the defined security schemes, freshly computed everytime.
Do not call this method without doing authentication first and having a userinfo property.
Returns:
| Type | Description |
|---|---|
bool
|
|
Source code in repo/hololinked/hololinked/server/http/handlers.py
is_method_allowed
async
Checks if the method is allowed for the property.
set_access_control_allow_headers
For credential login, access control allow headers cannot be a wildcard '*'.
Some requests require exact list of allowed headers for the client to access the response.
Source code in repo/hololinked/hololinked/server/http/handlers.py
set_custom_default_headers
Sets general default headers, override in child classes to add more headers.
Source code in repo/hololinked/hololinked/server/http/handlers.py
get_execution_parameters
get_execution_parameters() -> tuple[SchedulerExecutionContext, ThingExecutionContext, LocalExecutionContext, SerializableData]
Aggregates all arguments to a standard dataclasses from the query parameters.
Retrieves execution context (like oneway calls, fetching executing
logs), timeouts, etc. Non recognized arguments are passed as additional payload to the Thing.
An example would be the following URL:
scheduler execution context would have oneway set to true & invokationTimeout set to 5 seconds,
local execution context would be empty as no such arguments were passed,
and additional payload would have {"some_arg": 42} as its value.
Returns:
| Type | Description |
|---|---|
tuple[
|
SchedulerExecutionContext, ThingExecutionContext, LocalExecutionContext, SerializableData, |
]
|
scheduler execution context, thing execution context, local execution context and payload (if any) |
Source code in repo/hololinked/hololinked/server/http/handlers.py
256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 | |
get_request_payload
Retrieves the payload from the request body, does not necessarily deserialize it.
Returns:
| Type | Description |
|---|---|
tuple[SerializableData, PreserializedData]
|
the request body as serializable data and as preserialized data - the body is carried by whichever of the two matches the request's content type |
Raises:
| Type | Description |
|---|---|
ValueError
|
if the request declares a content type that is not supported |
Source code in repo/hololinked/hololinked/server/http/handlers.py
get
async
Runs property or action if accessible by 'GET' method. Default for property reads.
Source code in repo/hololinked/hololinked/server/http/handlers.py
post
async
Runs property or action if accessible by 'POST' method. Default for action execution.
Source code in repo/hololinked/hololinked/server/http/handlers.py
put
async
Runs property or action if accessible by 'PUT' method. Default for property writes.
Source code in repo/hololinked/hololinked/server/http/handlers.py
delete
async
Runs property or action if accessible by 'DELETE' method.
Default for property deletes (not a valid operation as per web of things semantics).